Bug 910148 - Review Request: nodejs-connect - High performance middleware framework for Node.js
Summary: Review Request: nodejs-connect - High performance middleware framework for No...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 910116 910118 910121 910123 910124 910125 910127 910138 910139 910142
Blocks: 910150 910154
TreeView+ depends on / blocked
 
Reported: 2013-02-11 21:54 UTC by Jamie Nguyen
Modified: 2013-06-16 18:33 UTC (History)
3 users (show)

Fixed In Version: nodejs-connect-2.7.10-1.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-03-19 14:12:20 UTC
tom: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jamie Nguyen 2013-02-11 21:54:26 UTC
Spec URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/nodejs-connect.spec
SRPM URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/SRPMS/nodejs-connect-2.7.2-1.fc18.src.rpm
Fedora Account System Username: jamielinux

Description:
Connect is an extensible HTTP server framework for node, providing high
performance "plugins" known as middleware.

Connect is bundled with over 20 commonly used middleware, including a logger,
session support, cookie parser, and more.

Comment 4 Tom Hughes 2013-02-25 20:33:24 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: %check is present and all tests pass.

I'm seeing 11 test failures when the tests are enabled.

[!]: Package complies to the Packaging Guidelines

Per https://fedoraproject.org/wiki/Packaging:Node.js#Installing_Modules
the images should I believe be installed in %{_datadir}?

Also, should lib-cov be installed? It's just a copy of lib annotated
for coverage testing isn't it?


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[!]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (connect-2.7.3.tgz) Source1 (tests-2.7.3.tar.bz2) Source10
     (dl-tests.sh)
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: nodejs-connect-2.7.3-1.fc19.noarch.rpm
          nodejs-connect-2.7.3-1.fc19.src.rpm
nodejs-connect.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-connect.noarch: W: only-non-binary-in-usr-lib
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/qs /usr/lib/node_modules/qs
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/buffer-crc32 /usr/lib/node_modules/buffer-crc32
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/cookie /usr/lib/node_modules/cookie
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/formidable /usr/lib/node_modules/formidable
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/bytes /usr/lib/node_modules/bytes
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/debug /usr/lib/node_modules/debug
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/fresh /usr/lib/node_modules/fresh
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/send /usr/lib/node_modules/send
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/pause /usr/lib/node_modules/pause
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/cookie-signature /usr/lib/node_modules/cookie-signature
nodejs-connect.src: W: spelling-error Summary(en_US) middleware -> middle ware, middle-ware, middleweight
nodejs-connect.src: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-connect.src: W: spelling-error %description -l en_US middleware -> middle ware, middle-ware, middleweight
nodejs-connect.src: W: strange-permission dl-tests.sh 0755L
nodejs-connect.src: W: invalid-url Source1: tests-2.7.3.tar.bz2
2 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-connect
nodejs-connect.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-connect.noarch: W: only-non-binary-in-usr-lib
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/qs /usr/lib/node_modules/qs
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/buffer-crc32 /usr/lib/node_modules/buffer-crc32
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/cookie /usr/lib/node_modules/cookie
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/formidable /usr/lib/node_modules/formidable
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/bytes /usr/lib/node_modules/bytes
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/debug /usr/lib/node_modules/debug
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/fresh /usr/lib/node_modules/fresh
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/send /usr/lib/node_modules/send
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/pause /usr/lib/node_modules/pause
nodejs-connect.noarch: W: dangling-symlink /usr/lib/node_modules/connect/node_modules/cookie-signature /usr/lib/node_modules/cookie-signature
1 packages and 0 specfiles checked; 0 errors, 12 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-connect-2.7.3-1.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    nodejs(engine) >= 0.5.0
    npm(buffer-crc32) < 1
    npm(buffer-crc32) >= 0.1
    npm(bytes) < 1
    npm(bytes) >= 0.1
    npm(cookie) = 0.0.5
    npm(cookie-signature) = 0.0.1
    npm(debug)
    npm(formidable) = 1.0.11
    npm(fresh) = 0.1.0
    npm(pause) = 0.0.1
    npm(qs) < 0.6
    npm(qs) >= 0.5
    npm(send) = 0.1.0



Provides
--------
nodejs-connect-2.7.3-1.fc19.noarch.rpm:
    
    nodejs-connect = 2.7.3-1.fc19
    npm(connect) = 2.7.3



MD5-sum check
-------------
http://registry.npmjs.org/connect/-/connect-2.7.3.tgz :
  CHECKSUM(SHA256) this package     : 9feb486d2676786622553e733d845395847cec11b951e8fbd0f7bd7919ec728c
  CHECKSUM(SHA256) upstream package : 9feb486d2676786622553e733d845395847cec11b951e8fbd0f7bd7919ec728c


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 910148

Comment 5 Jamie Nguyen 2013-02-25 22:02:55 UTC
> [!]: %check is present and all tests pass.
>
> I'm seeing 11 test failures when the tests are enabled.

Hmm, indeed my notes seem to say the same. Sorry, I must have forgotten about this. Will try to fix.


> [!]: Package complies to the Packaging Guidelines
>
> Per https://fedoraproject.org/wiki/Packaging:Node.js#Installing_Modules
> the images should I believe be installed in %{_datadir}?

Yes I believe you're right.


> Also, should lib-cov be installed? It's just a copy of lib annotated
> for coverage testing isn't it?

Correct. I thought I'd removed that from all of my review requests. A grep of my specs seems to confirm this is the only case where I forgot!


New Spec/SRPM coming soon.

Comment 6 Jamie Nguyen 2013-03-10 18:54:11 UTC
Spec URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/nodejs-connect.spec
SRPM URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/SRPMS/nodejs-connect-2.7.3-2.fc18.src.rpm


> [!]: %check is present and all tests pass.
> 
> I'm seeing 11 test failures when the tests are enabled.

I fixed 2 of them. Most of the remaining errors are multipart/form-data related and seem to be the same upstream (who also have some other errors too):
https://travis-ci.org/senchalabs/connect/jobs/4916390

Not sure if switching from formidable to parted will fix things, but progress on that seems to have stalled:
https://github.com/senchalabs/connect/issues/673


> Also, should lib-cov be installed?

Removed.

Comment 7 Tom Hughes 2013-03-10 19:26:26 UTC
Great. The only thing I'm wondering about now is whether the symlinking to %{_datadir} is acceptable - the guidelines say that the "module should be patched to cope with that".

It would certainly make life easier if it was allowed as it avoids the issue I had with nodejs-mapnik-reference of needing to keep an unpatched copy for running tests...

Comment 8 Jamie Nguyen 2013-03-10 20:12:29 UTC
A while ago I asked T.C. Hollingsworth (who I assume has been involved in the drafting of those guidelines) about this via private email:

T.C. Hollingsworth wrote:
> Jamie Nguyen wrote:
>> Presumably then a line like:
>> fs.readFile(__dirname + '/../public/style.css', 'utf8', function(e, style)
>>
>> Would have to be patched to:
>> fs.readFile('/usr/share/nodejs-connect/public/style.css', 'utf8',
>> function(e, style)
>
> Or you could just symlink the public directory in
> %{nodejs_sitelib}/connect to the proper location in %{_datadir}.  That
> way you don't have to carry and update a non-upstreamable patch
> forever.  


So I think it's fine.

Comment 9 Tom Hughes 2013-03-10 20:23:31 UTC
Sounds good to me. Package approved.

Comment 10 Jamie Nguyen 2013-03-10 20:32:25 UTC
New Package SCM Request
=======================
Package Name: nodejs-connect
Short Description: High performance middleware framework for Node.js 
Owners: jamielinux
Branches: f18 el6
InitialCC:

Comment 11 Gwyn Ciesla 2013-03-11 12:17:56 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2013-03-11 22:03:55 UTC
nodejs-connect-2.7.3-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-connect-2.7.3-2.fc18

Comment 13 Fedora Update System 2013-03-12 08:54:56 UTC
nodejs-connect-2.7.3-2.fc18 has been pushed to the Fedora 18 testing repository.

Comment 14 Fedora Update System 2013-03-15 07:19:39 UTC
nodejs-connect-2.7.3-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-connect-2.7.3-3.fc18

Comment 15 Fedora Update System 2013-04-07 00:40:46 UTC
nodejs-connect-2.7.3-3.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2013-05-25 16:40:22 UTC
nodejs-connect-2.7.10-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/nodejs-connect-2.7.10-1.el6

Comment 17 Fedora Update System 2013-06-16 18:33:21 UTC
nodejs-connect-2.7.10-1.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.